﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
#if METRO
using System.Threading.Tasks;
#else
using System.ComponentModel;
using System.Reflection;
#endif
namespace Spritehand.FarseerHelper
{
    public class Utilities
    {
        public static bool IsDesignMode
        {
            get
            {
#if METRO
                return Windows.ApplicationModel.DesignMode.DesignModeEnabled;
#else
                return DesignerProperties.IsInDesignTool;

#endif
            }

        }

        public static bool IsDebugMode
        {
            get
            {
                return (System.Diagnostics.Debugger.IsAttached);
            }
        }

        public static string GetCurrentVersion()
        {
#if METRO
            return Windows.ApplicationModel.Package.Current.Id.Version.Major.ToString() + "." +
                 Windows.ApplicationModel.Package.Current.Id.Version.Minor.ToString() + "." +
                 Windows.ApplicationModel.Package.Current.Id.Version.Revision.ToString();
#else
            Assembly assembly = Assembly.GetExecutingAssembly();

            string assemblyLong = assembly.ToString();

            return assemblyLong.Substring(assemblyLong.IndexOf('=') + 1, 
                assemblyLong.IndexOf(',', assemblyLong.IndexOf('=')) - assemblyLong.IndexOf('=') - 1);

#endif
        }

        public static int VersionToNumeric(string version)
        {
            int retval = 0;

            // if no version then default to first release
            if (version == null)
                version = "1.0.1";

            string[] versionSplits = version.Split('.');

            for (int i = 0; i < versionSplits.Length; i++)
            {
                retval += Convert.ToInt32(Math.Pow(1000, (versionSplits.Length - i - 1)) * Convert.ToInt32(versionSplits[i])); 
            }

            return retval;
        }


    }
}
